DEFINT A-Z

SHARED VIDSEG&, PAGESIZE%
%YES = -1	 ' equate for clarity

' Save initial state of system; gather necessary system info
CALL HouseKeeping

' Fancy clear video page 0
Char% = 191 : Fore% = 11 : Back% = 1
CALL FancyCls(Fore%, Back%, Char%)
WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke

' While showing page 0, prepare page 1:
' Make page 1 active only (not visible)
SCREEN ,,1,0

' Fancy clear page 1
Char% = 250 : Fore% = 7 : Back% = 4
CALL FancyCls(Fore%, Back%, Char%)

' Print on page 1
COLOR 15, 1
LOCATE 5, 30 : PRINT "Here's video page 1"

' Now show page 1
SCREEN ,,1,1
WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke

' Make page 0 active.  Leave page 1 visible.
SCREEN ,,0,1

' Print on page 0
COLOR 14, 3
LOCATE 8, 28 : PRINT "Back to video page 0"

' Now make page 0 visible
SCREEN ,,,0
WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke

' Restore initial state
CALL HouseKeeping
END


' Gathers necessary system info
' Saves and restores initial system state

SUB HouseKeeping STATIC
  IF ISTRUE(beenhere%) THEN GOTO CleanUp

  IF ISFALSE(pbvScrnCard AND 1) THEN
    VIDSEG&=&HB800 'color system
  ELSE
    VIDSEG&=&HB000 'monochrome
  END IF

  IF pbvScrnCols = 80 THEN
    PAGESIZE% = 4096
  ELSE
    PAGESIZE% = 2048
  END IF

  ' Save video page 0
  startscrn$ = SaveScreen$(0)
  row% = CSRLIN : col% = POS(x)
  curstate% = pbvCursorVis
  beenhere% = %YES
  EXIT SUB

CleanUp:
  ' Restore startscreen$ to page 0
  CALL RestoreScreen(0, startscrn$)
  ' Avoid the double line scrolling
  IF row% > 1 THEN DECR row%
  LOCATE row%, col%, curstate%
END SUB


' Clears active video page

SUB FancyCls(BYVAL Fore%, BYVAL Back%, BYVAL Char%)
  LOCAL t$, attr%

  ' If mono system, change to white on black
  IF VIDSEG& = &HB000 THEN
    Fore% = 7 : Back% = 0
  END IF

  attr% = Fore% + (Back% * 16)
  t$ = REPEAT$(PAGESIZE% \ 2, CHR$(Char%, attr%))
  DEF SEG = VIDSEG&
  POKE$ pbvScrnApage * PAGESIZE%, t$
  DEF SEG
END SUB


' Saves active video page
' Uses function VideoAddr%

FUNCTION SaveScreen$(BYVAL VPage%) STATIC
  DEF SEG = VIDSEG&
  SaveScreen$ = PEEK$(VPage% * PAGESIZE%, PAGESIZE%)
  DEF SEG
END FUNCTION


' Restores saved screen to active video page
' Uses function VideoAddr%

SUB RestoreScreen(BYVAL VPage%, SavedScrn$) STATIC
  DEF SEG = VIDSEG&
  POKE$ VPage% * PAGESIZE%, SavedScrn$
  DEF SEG
END SUB
